#include "main.h"


//Random Byte Write
uint8_t AT24WriteByte(uint8_t deviceaddress, uint16_t dataaddress, uint8_t data){
	uint8_t SLA_W = deviceaddress + AT24Command; 
	TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
	while ((TWCR & 0x80)!= 0x80);
	TWDR = SLA_W;
	TWCR = (1<<TWINT) | (1<<TWEN);
	while ((TWCR & 0x80)!= 0x80);
	if (TWSR != 0x18){
		return 1;
		//Keine Antwort vom EEPROM
	}
	TWDR = ((dataaddress>>8)&0xFF);
	TWCR = (1<<TWINT) | (1<<TWEN);
	while ((TWCR & 0x80)!= 0x80);
	if (TWSR != 0x28){
		return 1;
		//Byte wurde nicht besttigt
	}
	TWDR = (dataaddress&0xFF);
	TWCR = (1<<TWINT) | (1<<TWEN);
	while ((TWCR & 0x80)!= 0x80);
	if (TWSR != 0x28){
		return 1;
		//Byte wurde nicht besttigt
	}
	TWDR = data;
	TWCR = (1<<TWINT) | (1<<TWEN);
	while ((TWCR & 0x80)!= 0x80);
	if (TWSR != 0x28){
		return 1;
		//Byte wurde nicht besttigt
	}
	TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO);
	return 0;
}

//Dummmy Random Write
uint8_t AT24DummyWriteByte(uint8_t deviceaddress, uint16_t dataaddress){
	uint8_t SLA_W = deviceaddress + AT24Command; 
	TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
	while ((TWCR & 0x80)!= 0x80);
	TWDR = SLA_W;
	TWCR = (1<<TWINT) | (1<<TWEN);
	while ((TWCR & 0x80)!= 0x80);
	if (TWSR != 0x18){
		return 1;
		//Keine Antwort vom EEPROM
	}
	TWDR = ((dataaddress>>8)&0xFF);
	TWCR = (1<<TWINT) | (1<<TWEN);
	while ((TWCR & 0x80)!= 0x80);
	if (TWSR != 0x28){
		return 1;
		//Byte wurde nicht besttigt
	}
	TWDR = (dataaddress&0xFF);
	TWCR = (1<<TWINT) | (1<<TWEN);
	while ((TWCR & 0x80)!= 0x80);
	if (TWSR != 0x28){
		return 1;
		//Byte wurde nicht besttigt
	}
	return 0;
}
	
//Random Read	
uint8_t AT24ReadByte(uint8_t deviceaddress,uint16_t dataaddress){
	uint8_t data=0x00;
	uint8_t SLA_R = deviceaddress + AT24Command+0x01; 
	AT24DummyWriteByte(deviceaddress,dataaddress);
	TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
	while ((TWCR & 0x80)!= 0x80);
	TWDR = SLA_R;
	TWCR = (1<<TWINT) | (1<<TWEN);
	while ((TWCR & 0x80)!= 0x80);
	if (TWSR != 0x40){
		// EEPROM antwortet nicht
	}
	TWCR = (1<<TWINT) | (1<<TWEN);
	while ((TWCR & 0x80)!= 0x80);
	data = TWDR;
	if (TWSR != 0x58){
		//Daten nicht besttigt
	}
	TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO);
	return data;
}

//Page Write
uint8_t AT24PageWrite(uint8_t deviceaddress, uint8_t * buffer, uint8_t bufferlength, uint8_t pagenumber){
	uint8_t x;
	uint8_t SLA_W = deviceaddress + AT24Command; 
	uint16_t dataaddress = pagenumber*32;
	TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
	while ((TWCR & 0x80)!= 0x80);
	TWDR = SLA_W;
	TWCR = (1<<TWINT) | (1<<TWEN);
	while ((TWCR & 0x80)!= 0x80);
	if (TWSR != 0x18){
		//return 1;
		//Keine Antwort vom EEPROM
	}
	TWDR = ((dataaddress>>8)&0xFF);
	TWCR = (1<<TWINT) | (1<<TWEN);
	while ((TWCR & 0x80)!= 0x80);
	if (TWSR != 0x28){
		//return 1;
		//Byte wurde nicht besttigt
	}
	TWDR = (dataaddress&0xFF);
	TWCR = (1<<TWINT) | (1<<TWEN);
	while ((TWCR & 0x80)!= 0x80);
	if (TWSR != 0x28){
		//return 1;
		//Byte wurde nicht besttigt
	}
	for(x = 0; x< bufferlength; x++){
		TWDR = *buffer;
		buffer++;
		TWCR = (1<<TWINT) | (1<<TWEN);
		while ((TWCR & 0x80)!= 0x80);
		if (TWSR != 0x28){
			//return 1;
			//Byte wurde nicht besttigt
		}
	}
	TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO);
	return 0;
}



//Page Read
uint8_t AT24PageRead(uint8_t deviceaddress,uint8_t *buffer,uint8_t bytestoread, uint8_t pagenumber){
	uint8_t data=0x00,x;
	uint16_t dataaddress=pagenumber*32;
	AT24DummyWriteByte(deviceaddress,dataaddress);
		TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
		while ((TWCR & 0x80)!= 0x80);
		TWDR = (deviceaddress+AT24Command)|0x01;
		TWCR = (1<<TWINT) | (1<<TWEN);
		while ((TWCR & 0x80)!= 0x80);
		if (TWSR != 0x40){
			return 1;
			// EEPROM antwortet nicht
		}
		if(bytestoread > 1){
			for(x=0;x<bytestoread-1;x++){
				TWCR = (1<<TWINT) | (1<<TWEN)|(1<<TWEA);
				while ((TWCR & 0x80)!= 0x80);
				*buffer = TWDR;
				buffer++;
				if (TWSR != 0x50){
					return 1;
					//Daten nicht besttigt
				}
			}
		}
			TWCR = (1<<TWINT) | (1<<TWEN);
				while ((TWCR & 0x80)!= 0x80);
				*buffer = TWDR;
				buffer++;
				if (TWSR != 0x58){
					return 1;
					//Daten nicht besttigt
				}
		TWCR = (1<<TWINT)|(1<<TWEN)|(1<<TWSTO);
	
	
	return 0;
}
//Poll EEPROM (read = 1, write = 0);
uint8_t AT24Poll(uint8_t deviceaddress,uint8_t rw){
	uint8_t SLA_R = deviceaddress + AT24Command+0x01; 
	uint8_t SLA_W = deviceaddress + AT24Command; 
	uint8_t ready=0x00;
	while(ready!=0x01){
		switch(rw){
			case 0:
			TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
			while ((TWCR & 0x80)!= 0x80);
			TWDR = SLA_W;
			TWCR = (1<<TWINT) | (1<<TWEN);
			while ((TWCR & 0x80)!= 0x80);
			if (TWSR == 0x18){
			ready=0x01;
			}
			break;
			case 1:
			TWCR = (1<<TWINT)|(1<<TWSTA)|(1<<TWEN);
			while ((TWCR & 0x80)!= 0x80);
			TWDR = SLA_R;
			TWCR = (1<<TWINT) | (1<<TWEN);
			while ((TWCR & 0x80)!= 0x80);
			if (TWSR == 0x40){
			ready=0x01;
			}
			break;
		}
	}
	
}
